VarGenot <- function(infi, outf, namY, namX, NumSims = 1000) 
{
  d <- read.csv(infi)
  y <- d[namY]
  x <- d[namX]

  cat("File: ", infi, "; Trait: ", namY, "; Locus: ", namX, "\n", file=outf, append=TRUE)
  y <- as.vector(scale(y))

  #library(MASS)
  #library(car)
  #y <- 1/100 + y - min(y)
  #j <- boxcox(y ~ 1, plotit=FALSE); la <- j$x[which.max(j$y)]; y <- box.cox(y,la)

  GetChi <- function(y, x, outf, verb=0) {
    n0 <- length(y[x==0])
    y0 <- y[x==0]
    v0 <- var(y0) * (n0-1)/n0
    m0 <- mean(y0)

    n1 <- length(y[x==1])
    y1 <- y[x==1]
    v1 <- var(y1) * (n1-1)/n1
    m1 <- mean(y1)

    n2 <- length(y[x==2])
    y2 <- y[x==2]
    v2 <- var(y2) * (n2-1)/n2
    m2 <- mean(y2)

    n <- n0+n1+n2
    v <- (v0*n0 + v1*n1 + v2*n2) / n

    lmv0 <- dnorm(y0, m0, sqrt(v0), log=TRUE)
    lmv1 <- dnorm(y1, m1, sqrt(v1), log=TRUE)
    lmv2 <- dnorm(y2, m2, sqrt(v2), log=TRUE)
    lmv <- sum(lmv0)+sum(lmv1)+sum(lmv2)
    lm0 <- dnorm(y0, m0, sqrt(v), log=TRUE)
    lm1 <- dnorm(y1, m1, sqrt(v), log=TRUE)
    lm2 <- dnorm(y2, m2, sqrt(v), log=TRUE)
    lm <- sum(lm0)+sum(lm1)+sum(lm2)
    vfull <- var(y) * (n-1)/n
    mfull <- mean(y)
    l0 <- sum(dnorm(y, mfull, sqrt(vfull), log=TRUE))
    x2m <- 2*(lm-l0)
    x2mv <- 2*(lmv-l0)
    x2v <- 2*(lmv-lm)
    if(verb) {
      cat("QTL mean value with no target haplotype =", m2, "\n", file=outf,append=TRUE)
      cat("QTL mean value with 1 target haplotype =", m1, "\n", file=outf,append=TRUE)
      cat("QTL mean value with 2 target haplotypes =", m0, "\n", file=outf,append=TRUE)
      cat("QTL var =", v, "\n", file=outf,append=TRUE)
      cat("QTL var with no target haplotype =", v2, "\n", file=outf,append=TRUE)
      cat("QTL var with 1 target haplotype =", v1, "\n", file=outf,append=TRUE)
      cat("QTL var with 2 target haplotypes =", v0, "\n", file=outf,append=TRUE)
      cat("Genotype model; Mean chi-square =", x2m, file=outf,append=TRUE)
      cat("; p-value =", 1-pchisq(x2m,2), "\n", file=outf,append=TRUE)
      cat("Genotype model; Mean+Var chi-square =", x2mv, file=outf,append=TRUE)
      cat("; p-value =", 1-pchisq(x2mv,4), "\n", file=outf,append=TRUE)
      cat("Genotype model; Var chi-square =", x2v, file=outf,append=TRUE)
      cat("; p-value =", 1-pchisq(x2v,2), "\n", file=outf,append=TRUE)
    }
    return (c(x2m, x2mv, x2v))
  }

  k <- c(0,0,0)
  x0 <- GetChi(y, x, outf, verb=1)
  for(i in 1:NumSims) {
    yj <- sample(y, replace=FALSE)
    xi <- GetChi(yj, x, outf, verb=0)
    k[xi >= x0] <- k[xi >= x0]+1
  }

  pp <- k/NumSims
  cat("Perm p-values:", pp[1], ",", pp[2], ",", pp[3], "\n\n", file=outf,append=TRUE)
}
